'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbsearchlite.exe"
#Debug Error On
#Debug Display On
#Dim All
#Include "win32api.inc"
#Resource Icon, aaa, "files\search.ico"
#Resource Icon, xfolder, "files\open.ico"
#Resource Icon, xsubfolders, "files\subfolders.ico"
#Resource Icon, xallfiles, "files\all.ico"
#Resource Icon, xmatchcase, "files\match.ico"
#Resource Icon, xsettings, "files\settings.ico"
#Resource Icon, xhelp, "files\help.ico"
#Resource Icon, xcontext, "files\context.ico"
#Resource Icon, xlinenumber, "files\linenumber.ico"
#Resource Icon, xfiles, "files\files.ico"
#Resource Icon, xallwords, "files\allwords.ico"
#Resource Icon, xorwords, "files\orwords.ico"
#Resource Icon, xandwords, "files\andwords.ico"
#Resource Icon, xregex, "files\regexwords.ico"
#Resource Icon, xsearchall, "files\searchall.ico"

Declare Function PATHMATCHSPEC Lib "SHLWAPI.DLL" Alias "PathMatchSpecA" ( pszFile As AsciiZ, pszSpec As AsciiZ ) As Long

%DisplayFiles = 1
%DisplayNumbers = 2
%DisplayContext = 3

%SearchString = 1
%SearchAll = 2
%SearchAny = 3
%SearchRegExpr = 4

$ValidCharacters = Chr$(48 To 57, 65 To 90, 95, 97 To 122)

%IDT_Folder     = 400
%IDT_Search     = 401
%IDT_SubFolders = 402
%IDT_MatchCase  = 403
%IDT_Settings   = 404
%IDT_Files      = 405
%IDT_LineNumbers= 406
%IDT_Context    = 407
%IDT_AllWords   = 408
%IDT_AndWords   = 409
%IDT_OrWords    = 410
%IDT_RegEx      = 411
%IDT_SearchAll  = 412
%IDT_Help       = 413

%IDC_ComboTerms    = 500
%IDC_ComboParent   = 501
%IDC_ComboFileSpec = 502
%IDC_ListView      = 503
%IDC_SearchString  = 504
%IDC_Toolbar       = 506
%IDC_StatusBar     = 507

%IDM_Files         = 550
%IDM_Lines         = 551
%IDM_Context       = 552
%IDM_ContextWidth  = 553
%IDM_Sep           = 554
%IDM_ColorLines    = 555
%IDM_AutoSearch    = 556
%IDM_SelectFont    = 557

%IDM_CutTerms      = 600
%IDM_CopyTerms     = 601
%IDM_PasteTerms    = 602
%IDM_DeleteTerms   = 603
%IDM_ClearTerms    = 604

%IDM_CutParent     = 610
%IDM_CopyParent    = 611
%IDM_PasteParent   = 612
%IDM_DeleteParent  = 613
%IDM_ClearParent   = 614
%IDM_UpOneLevel    = 615
%IDM_OpenParent    = 616

%IDM_CutFileSpec   = 620
%IDM_CopyFileSpec  = 621
%IDM_PasteFileSpec = 622
%IDM_DeleteFileSpec= 623
%IDM_ClearFileSpec = 624

%IDM_FileHidden    = 651
%IDM_FileSystem    = 652
%IDM_ClearList     = 653
%IDM_MergeFile     = 654
%IDM_OpenLocation  = 655
%IDM_CopyList      = 656
%IDM_UseAsParent   = 657
%IDM_DetectUnix    = 658
%IDM_CompleteString= 659
%IDM_AllWords      = 660
%IDM_AnyWord       = 661
%IDM_WholeWords    = 662
%IDM_WordsOnLine   = 663
%IDM_TrimSearchString = 664
%IDM_RegExp        = 664
%IDM_WideToolbar   = 665
%IDM_ImpliedSearch = 666
%IDM_WideToolbarB  = 667


Global hDlg, hImageList, hToolbar, hPopUpSettings, ghHook, hListView, hFont, hFontT As Dword
Global hComboTerms, hComboParent, hComboFileSpec As Dword
Global hComboTermsEdit, hComboParentEdit, hComboFileSpecEdit As Dword
Global OldCBTermsProc, OldCBParentProc, OldCBFileSpecProc, OldLVProc, ColorLines, AutoSearch As Long
Global hContextTerms, hContextParent, hContextFileSpec, hContextListView As Dword
Global SearchString, FileSpec, ParentFolder, T(), txtLines() As String
Global MatchCase, SubFolders, AllFiles, DisplayMode, SearchMode, ContextWidth As Long
Global Folders(), Files() As DirData
Global FolderCount, FileCount, DetectUnix, WholeWords, WordsOnLine, MatchingFiles As Long
Global FileHidden, FileSystem, SortDirection As Long
Global WideToolbar, WideToolbarB, ImpliedSearch, FileColor, RowColor, LoadThisTime, TrimSearchString As Long
Global fontName As String, FontSize, FontStyle As Long
Global qFreq, qStart, qStop As Quad, DeltaTime As Single
Global colName, colPath, colDate, colSize As Long

Function PBMain() As Long
   Local style&
   style& = %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoVScroll _
             Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_VScroll Or %WS_ClipSiblings
   Font New "Tahoma", 8, 0 To hFontT
   Dialog New Pixels, 0, "gbSearchLite  v1.3",300,300,400,200, %WS_OverlappedWindow, 0 To hDlg
   Dialog Set Icon hDlg, "aaa"
   Control Add ComboBox, hDlg, %IDC_ComboTerms, , 10,50,200,100, %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ComboBox, hDlg, %IDC_ComboFileSpec, , 220,50,160,100, %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ComboBox, hDlg, %IDC_ComboParent, , 10,80,380,100, %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge
   Control Add ListView, hDlg, %IDC_ListView,"", 10,110,960,100, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel Or %WS_Border', %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer
   ListView Insert Column hDlg, %IDC_ListView, 1, "File Name", 80, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Full Path", 200, 0
   ListView Insert Column hDlg, %IDC_ListView, 3, "Date", 120, 0
   ListView Insert Column hDlg, %IDC_ListView, 4, "KB", 50, 1
   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h,iResult As Long, result$, temp$, nmtb As TBNotify Ptr
   Local rc As Rect, P As ToolTipText Ptr, lplvcd As NMLVCUSTOMDRAW Ptr, LVData As NM_ListView

   Select Case Cb.Msg
      Case %WM_InitDialog
          QueryPerformanceFrequency qFreq
          Control Set Font hDlg, %IDC_ComboTerms, hFontT
          Control Set Font hDlg, %IDC_ComboFileSpec, hFontT
          Control Set Font hDlg, %IDC_ComboParent, hFontT
          Control Set Font hDlg, %IDC_Toolbar, hFontT
          BuildAcceleratorTable
          CreateContextMenus
          CreateImageListPopup
          SubClassControls  '3 comboboxes and ListView
          ReDim Folders(500), Files(5000)
          Settings_INI "get"
          CreateToolbar
          Font New FontName, FontSize, FontStyle To hFont
          Control Set Font hDlg, %IDC_ListView, hFont
          SetMenusAndToolbarButtons
          ComboBox Select hDlg, %IDC_ComboTerms, 1    : PostMessage hComboTermsEdit, %EM_SetSel, 0,0
          ComboBox Select hDlg, %IDC_ComboParent, 1   : PostMessage hComboParentEdit, %EM_SetSel, 0,0
          ComboBox Select hDlg, %IDC_ComboFileSpec, 1 : PostMessage hComboFileSpecEdit, %EM_SetSel, 0,0
          If FileCount And AutoSearch Then Search(1) Else RestoreSession
          Control Set Focus hDlg, %IDC_ComboTerms

      Case %WM_Destroy
          Control Get Text hDlg, %IDC_ComboTerms To searchstring
          Control Get Text hDlg, %IDC_ComboFileSpec To filespec
          Control Get Text hDlg, %IDC_ComboParent To parentfolder : parentfolder = Trim$(parentfolder,"\")
          Settings_INI "save"
          SaveSession
          SetWindowLong hComboTermsEdit, %GWL_WNDPROC, OldCBTermsProc   'un-subclass
          SetWindowLong hComboParentEdit, %GWL_WNDPROC, OldCBParentProc   'un-subclass
          SetWindowLong hComboFileSpecEdit, %GWL_WNDPROC, OldCBFileSpecProc   'un-subclass
          SetWindowLong hListView, %GWL_WNDPROC, OldLVProc   'un-subclass
      Case %WM_Command
          Select Case Cb.Ctl
              Case %IDM_CutTerms     : SendMessage hComboTerms, %WM_CUT, 0, 0
              Case %IDM_CopyTerms    : SendMessage hComboTerms, %WM_COPY, 0, 0
              Case %IDM_PasteTerms   : SendMessage hComboTerms, %WM_PASTE, 0, 0
              Case %IDM_DeleteTerms  : SendMessage hComboTerms, %WM_CLEAR, 0, 0
              Case %IDM_ClearTerms   : ComboBox Reset hDlg, %IDC_ComboTerms
              Case %IDM_UpOneLevel
                  Control Get Text hDlg, %IDC_ComboParent To temp$
                  temp$ = RTrim$(temp$,"\")
                  temp$ = Left$(temp$, InStr(-1,temp$,"\")-1)
                  Control Set Text hDlg, %IDC_ComboParent, temp$
              Case %IDM_OpenParent
                  ComboBox Get Text hDlg, %IDC_ComboParent To temp$
                  iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

              Case %IDM_CutParent     : SendMessage hComboParent, %WM_CUT, 0, 0
              Case %IDM_CopyParent    : SendMessage hComboParent, %WM_COPY, 0, 0
              Case %IDM_PasteParent   : SendMessage hComboParent, %WM_PASTE, 0, 0
              Case %IDM_DeleteParent  : SendMessage hComboParent, %WM_CLEAR, 0, 0
              Case %IDM_ClearParent   : ComboBox Reset hDlg, %IDC_ComboParent

              Case %IDM_CutFileSpec     : SendMessage hComboFileSpec, %WM_CUT, 0, 0
              Case %IDM_CopyFileSpec    : SendMessage hComboFileSpec, %WM_COPY, 0, 0
              Case %IDM_PasteFileSpec   : SendMessage hComboFileSpec, %WM_PASTE, 0, 0
              Case %IDM_DeleteFileSpec  : SendMessage hComboFileSpec, %WM_CLEAR, 0, 0
              Case %IDM_ClearFileSpec   : ComboBox Reset hDlg, %IDC_ComboFileSpec

              Case %IDT_Folder     : SelectFolder
              Case %IDT_Search     : Search(1)  'full search, update Files()/Folders()
              Case %IDT_SearchAll  : AllFiles = 1 : Search(1) : AllFiles = 0

              Case %IDT_SubFolders : SubFolders = SubFolders Xor 1
              Case %IDT_MatchCase  : MatchCase = MatchCase Xor 1
              Case %IDT_Settings
                  ListView Get Count hDlg, %IDC_ListView To iResult
                  If IResult Then
                     Incr DisplayMode : If DisplayMode = 4 Then DisplayMode = 1
                     SetMenusAndToolbarButtons
                     MousePtr 11
                     SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %False, 0
                     Search(0)   '0=do not update Files()/Folders()
                     SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %True, 0
                     MousePtr 1
                  End If

              Case %IDM_CompleteString, %IDT_Allwords : SearchMode = 1 : SetMenusAndToolbarButtons
              Case %IDM_AllWords, %IDT_AndWords       : SearchMode = 2 : SetMenusAndToolbarButtons
              Case %IDM_AnyWord, %IDT_OrWords         : SearchMode = 3 : SetMenusAndToolbarButtons
              Case %IDM_RegExp, %IDT_RegEx            : SearchMode = 4 : SetMenusAndToolbarButtons

              Case %IDM_ImpliedSearch  : ImpliedSearch = ImpliedSearch Xor 1 : SetMenusAndToolbarButtons

              Case %IDM_WideToolbarB
                 WideToolbarB = WideToolbarB Xor 1
                 Control Kill hDlg, %IDC_Toolbar
                 CreateToolbar
                 SetMenusAndToolbarButtons

              Case %IDM_WideToolbar
                 WideToolbar = WideToolbar Xor 1
                 Control Kill hDlg, %IDC_Toolbar
                 CreateToolbar
                 SetMenusAndToolbarButtons

              Case %IDM_Files, %IDT_Files         : DisplayMode = 1 : SetMenusAndToolbarButtons : Search(0)
              Case %IDM_Lines, %IDT_LineNumbers   : DisplayMode = 2 : SetMenusAndToolbarButtons : Search(0)
              Case %IDM_Context, %IDT_Context     : DisplayMode = 3 : SetMenusAndToolbarButtons : Search(0)

              Case %IDM_ContextWidth  :  EnterContextWidth
              Case %IDT_Help       :
                   temp$ = "http://www.garybeene.com/sw/gbsearchlite.htm"
                   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
              Case %IdOk
                  Select Case GetFocus
                      Case hComboTermsEdit    : Search(1)  'full search, update Files()/Folders()
                      Case hComboParentEdit   : Search(1)  'full search, update Files()/Folders()
                      Case hComboFileSpecEdit : Search(1)  'full search, update Files()/Folders()
                      Case hListView
                           ListView Get Select hDlg, %IDC_ListView To iResult
                           ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                           iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  End Select
              Case %IDM_FileHidden : FileHidden = FileHidden Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_FileSystem : FileSystem = FileSystem Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_ClearList  : ListView Reset hDlg, %IDC_ListView : ResizeWindow
              Case %IDM_MergeFile  : CreateMergeFile
              Case %IDM_OpenLocation
                  ListView Get Select hDlg, %IDC_ListView To iResult
                  ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                  temp$ = PathName$(Path,temp$)
                  iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
              Case %IDM_CopyList
                  For x = 0 To FileCount
                      ListView Get Text hDlg, %IDC_ListView, x+1,2 To temp$
                      result$ = result$ + $CrLf + Files(x).FileName
                  Next x
                  Clipboard Reset
                  Clipboard Set Text Trim$(result$,$CrLf)
              Case %IDM_UseAsParent
                  ListView Get Select hDlg, %IDC_ListView To iResult
                  ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                  Control Set Text hDlg, %IDC_ComboParent, Trim$(PathName$(Path,temp$),"\")
              Case %IDM_ColorLines  : ColorLines = ColorLines Xor 1 : SetMenusAndToolbarButtons
                  Control ReDraw hDlg, %IDC_ListView
              Case %IDM_AutoSearch  : AutoSearch = AutoSearch Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_SelectFont  : SelectAppFont
              Case %IDM_TrimSearchString : TrimSearchString = TrimSearchString Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_DetectUnix
                  DetectUnix = DetectUnix Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_WholeWords
                  WholeWords = WholeWords Xor 1 : SetMenusAndToolbarButtons
              Case %IDM_WordsOnLine
                  WordsOnLine = WordsOnLine Xor 1 : SetMenusAndToolbarButtons
          End Select
       Case %WM_Size
           ResizeWindow
       Case %WM_User + 500
           ResizeColumns(Cb.WParam)
           ResizeWindow
      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Folder To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
               Case %IDC_ListView
                   Select Case Cb.NmCode
                       Case %LVN_ItemChanged
                       Case %LVN_ColumnClick
                           MousePtr 11
                           SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %False, 0
                           SortDirection = SortDirection Xor 1
                           Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                           Select Case LVData.iSubItem+1
                               Case 1
                                  If SortDirection = 1 Then Array Sort Files(1) For FileCount, Call SortByNameA()
                                  If SortDirection = 0 Then Array Sort Files(1) For FileCount, Call SortByNameD()
                               Case 2
                                  If SortDirection = 1 Then Array Sort Files(1) For FileCount, Call SortByPathA()
                                  If SortDirection = 0 Then Array Sort Files(1) For FileCount, Call SortByPathD()
                               Case 3
                                  If SortDirection = 1 Then Array Sort Files(1) For FileCount, Call SortByDateA()
                                  If SortDirection = 0 Then Array Sort Files(1) For FileCount, Call SortByDateD()
                               Case 4
                                  If SortDirection = 1 Then Array Sort Files(1) For FileCount, Call SortBySizeA()
                                  If SortDirection = 0 Then Array Sort Files(1) For FileCount, Call SortBySizeD()
                           End Select
                           Search(0)   '0=do not update Files()/Folders()
                           SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %True, 0
                           MousePtr 1
                       Case %NM_DblClk
                           ListView Get Select hDlg, %IDC_ListView To iResult
                           ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                           iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                       Case %NM_CustomDraw
                           If ColorLines Then
                               lplvcd = Cb.LParam
                               Select Case @lplvcd.nmcd.dwDrawStage
                                   Case %CDDS_PrePaint
                                       Function = %CDRF_NOTIFYITEMDRAW : Exit Function
                                   Case %CDDS_ItemPrePaint
                                       Select Case @lplvcd.nmcd.dwItemSpec Mod 6
                                           Case 3,4,5
                                               @lplvcd.clrTextBk = FileColor  'item BG color
                                       End Select
                                       Function = %CDRF_NEWFONT : Exit Function   'change item/subitem BG colors
                               End Select
                           End If
                 End Select
           End Select
      Case %WM_ContextMenu
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextListView, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
    End Select
End Function

Sub SelectFolder
   Local title$, start$, flags&, folder$, sfolder$
   Control Get Text hDlg, %IDC_ComboParent To sFolder$
   title$ = "Select Starting Folder for Search"
   start$ = sFolder
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then Control Set Text hDlg, %IDC_ComboParent, folder$
End Sub

Sub Settings_INI(Task$)
   Local i,x,y As Long, xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path, temp$
   'set ini filename
   INIFileName = Exe.Path$ + "gbsearchlite.ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "420", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "275", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height
      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", tempz, %Max_Path, INIFileName : FontName = tempz
      Getprivateprofilestring "All", "LoadThisTime", "1", tempz, %Max_Path, INIFileName : LoadThisTime = Val(tempz)
      If LoadThisTime Then
          ComboBox Add hDlg, %IDC_ComboFileSpec, "*.txt"
          ComboBox Add hDlg, %IDC_ComboFileSpec, "*.bas;*.txt;*.inc;*.h;*.htm"
          ComboBox Add hDlg, %IDC_ComboFileSpec, "*.jpg;*.gif;*.bmp"
          ComboBox Add hDlg, %IDC_ComboFileSpec, "*.doc;*.xls"
          ComboBox Add hDlg, %IDC_ComboFileSpec, "*.exe;*.com"

          ComboBox Add hDlg, %IDC_ComboParent, "c:\temp"
          ComboBox Add hDlg, %IDC_ComboParent, "c:\data"
          ComboBox Add hDlg, %IDC_ComboParent, "c:\pbwin90\winapi"
          ComboBox Add hDlg, %IDC_ComboParent, "c:\pbwin10\winapi"
          ComboBox Add hDlg, %IDC_ComboParent, Trim$(Exe.Path$,"\")

          ComboBox Add hDlg, %IDC_ComboTerms, "<search string>"
          ComboBox Add hDlg, %IDC_ComboTerms, "Help"
          ComboBox Add hDlg, %IDC_ComboTerms, "Summary"
          ComboBox Add hDlg, %IDC_ComboTerms, "Status"
          ComboBox Add hDlg, %IDC_ComboTerms, "Results"
      Else
          GetPrivateProfileString "All", "FileSpec1", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
          GetPrivateProfileString "All", "FileSpec2", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
          GetPrivateProfileString "All", "FileSpec3", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
          GetPrivateProfileString "All", "FileSpec4", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$
          GetPrivateProfileString "All", "FileSpec5", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboFileSpec, temp$

          GetPrivateProfileString "All", "ParentFolder1", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboParent, temp$
          GetPrivateProfileString "All", "ParentFolder2", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboParent, temp$
          GetPrivateProfileString "All", "ParentFolder3", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboParent, temp$
          GetPrivateProfileString "All", "ParentFolder4", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboParent, temp$
          GetPrivateProfileString "All", "ParentFolder5", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboParent, temp$

          GetPrivateProfileString "All", "SearchString1", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboTerms, temp$
          GetPrivateProfileString "All", "SearchString2", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboTerms, temp$
          GetPrivateProfileString "All", "SearchString3", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboTerms, temp$
          GetPrivateProfileString "All", "SearchString4", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboTerms, temp$
          GetPrivateProfileString "All", "SearchString5", "", tempz, %Max_Path, INIFileName
          temp$ = tempz : ComboBox Add hDlg, %IDC_ComboTerms, temp$
      End If

      'get value for numeric variables
      Getprivateprofilestring "All", "colName", "15", tempz, %Max_Path, INIFileName
      colName = Val(tempz)
      Getprivateprofilestring "All", "colPath", "60", tempz, %Max_Path, INIFileName
      colPath = Val(tempz)
      Getprivateprofilestring "All", "colDate", "15", tempz, %Max_Path, INIFileName
      colDate = Val(tempz)
      Getprivateprofilestring "All", "colSize", "10", tempz, %Max_Path, INIFileName
      colSize = Val(tempz)
      Getprivateprofilestring "All", "WordsOnLine", "0", tempz, %Max_Path, INIFileName
      WordsOnLine = Val(tempz)
      Getprivateprofilestring "All", "DetectUnix", "0", tempz, %Max_Path, INIFileName
      DetectUnix = Val(tempz)
      Getprivateprofilestring "All", "Trim Search String", "1", tempz, %Max_Path, INIFileName
      TrimSearchString = Val(tempz)
      Getprivateprofilestring "All", "FontStyle", "0", tempz, %Max_Path, INIFileName
      AutoSearch = Val(tempz)
      Getprivateprofilestring "All", "FontSize", "8", tempz, %Max_Path, INIFileName
      FontSize = Val(tempz)
      Getprivateprofilestring "All", "AutoSearch", "0", tempz, %Max_Path, INIFileName
      AutoSearch = Val(tempz)
      Getprivateprofilestring "All", "FileCount", Str$(%rgb_Coral), tempz, %Max_Path, INIFileName
      FileCount = Val(tempz)
      Getprivateprofilestring "All", "FolderCount", Str$(%rgb_Coral), tempz, %Max_Path, INIFileName
      FolderCount = Val(tempz)
      Getprivateprofilestring "All", "RowColor", Str$(%rgb_Coral), tempz, %Max_Path, INIFileName
      RowColor = Val(tempz)
      Getprivateprofilestring "All", "FileColor", Str$(RGB(235,235,235)), tempz, %Max_Path, INIFileName
      FileColor = Val(tempz)
      Getprivateprofilestring "All", "ColorLines", "0", tempz, %Max_Path, INIFileName
      ColorLines = Val(tempz)
      Getprivateprofilestring "All", "FileHidden", "0", tempz, %Max_Path, INIFileName
      FileHidden = Val(tempz)
      Getprivateprofilestring "All", "FileSystem", "0", tempz, %Max_Path, INIFileName
      FileSystem = Val(tempz)
      Getprivateprofilestring "All", "MatchCase", "0", tempz, %Max_Path, INIFileName
      MatchCase = Val(tempz)
      Getprivateprofilestring "All", "SubFolders", "0", tempz, %Max_Path, INIFileName
      SubFolders = Val(tempz)
      Getprivateprofilestring "All", "AllFiles", "0", tempz, %Max_Path, INIFileName
      AllFiles = Val(tempz)
      Getprivateprofilestring "All", "SearchMode", "1", tempz, %Max_Path, INIFileName
      SearchMode = Val(tempz)  '1=string 2=allwords 3=anyword
      Getprivateprofilestring "All", "DisplayMode", "1", tempz, %Max_Path, INIFileName
      DisplayMode = Val(tempz)  '1=files  2=line numbers 3=line numbers+context lines
      Getprivateprofilestring "All", "ContextWidth", "3", tempz, %Max_Path, INIFileName
      ContextWidth = Val(tempz)
      Getprivateprofilestring "All", "WideToolbar", "0", tempz, %Max_Path, INIFileName
      WideToolbar = Val(tempz)
      Getprivateprofilestring "All", "ImpliedSearch", "0", tempz, %Max_Path, INIFileName
      ImpliedSearch = Val(tempz)

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      Dialog Get Client hDlg To x,y
      'save string variables
      WritePrivateProfileString "All", "FontName",(FontName), INIFileName
      For i = 1 To 5
          ComboBox Get Text hDlg, %IDC_ComboTerms, i To temp$
          WritePrivateProfileString "All", "SearchString" + Trim$(Str$(i)),(temp$), INIFileName
      Next i
      For i = 1 To 5
          ComboBox Get Text hDlg, %IDC_ComboParent, i To temp$
          WritePrivateProfileString "All", "ParentFolder" + Trim$(Str$(i)),(temp$), INIFileName
      Next i
      For i = 1 To 5
          ComboBox Get Text hDlg, %IDC_ComboFileSpec, i To temp$
          WritePrivateProfileString "All", "FileSpec" + Trim$(Str$(i)),(temp$), INIFileName
      Next i

      'save numeric variables
      WritePrivateProfileString "All", "colName", (Str$(colName)), INIFileName
      WritePrivateProfileString "All", "colPath", (Str$(colPath)), INIFileName
      WritePrivateProfileString "All", "colDate", (Str$(colDate)), INIFileName
      WritePrivateProfileString "All", "colSize", (Str$(colSize)), INIFileName
      WritePrivateProfileString "All", "WholeWords", (Str$(WholeWords)), INIFileName
      WritePrivateProfileString "All", "WordsOnLine", (Str$(WordsOnLine)), INIFileName
      WritePrivateProfileString "All", "DetectUnix", (Str$(DetectUnix)), INIFileName
      WritePrivateProfileString "All", "TrimSearchString", (Str$(TrimSearchString)), INIFileName
      WritePrivateProfileString "All", "FontStyle", (Str$(FontStyle)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "AutoSearch", (Str$(AutoSearch)), INIFileName
      WritePrivateProfileString "All", "FileCount", (Str$(FileCount)), INIFileName
      WritePrivateProfileString "All", "FolderCount", (Str$(FolderCount)), INIFileName
      WritePrivateProfileString "All", "LoadThisTime", "0", INIFileName
      WritePrivateProfileString "All", "RowColor", (Str$(RowColor)), INIFileName
      WritePrivateProfileString "All", "FileColor", (Str$(FileColor)), INIFileName
      WritePrivateProfileString "All", "ColorLines", (Str$(ColorLines)), INIFileName
      WritePrivateProfileString "All", "FileHidden", (Str$(FileHidden)), INIFileName
      WritePrivateProfileString "All", "FileSystem", (Str$(FileSystem)), INIFileName
      WritePrivateProfileString "All", "MatchCase", (Str$(MatchCase)), INIFileName
      WritePrivateProfileString "All", "SubFolders", (Str$(SubFolders)), INIFileName
      WritePrivateProfileString "All", "AllFiles", (Str$(AllFiles)), INIFileName
      WritePrivateProfileString "All", "SearchMode", (Str$(SearchMode)), INIFileName
      WritePrivateProfileString "All", "DisplayMode", (Str$(DisplayMode)), INIFileName
      WritePrivateProfileString "All", "ContextWidth", (Str$(ContextWidth)), INIFileName
      WritePrivateProfileString "All", "WideToolbar", (Str$(WideToolbar)), INIFileName
      WritePrivateProfileString "All", "ImpliedSearch", (Str$(ImpliedSearch)), INIFileName

   End If
End Sub

Sub Search(Flag As Long)            'Flag=1 means to update Files()/Folders() arrays
    Local text$, sterm$, i,lenS As Long
    MousePtr 11
    QueryPerformanceCounter qStart
    SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %False, 0

    'get textbox content
    Control Get Text hDlg, %IDC_ComboTerms To SearchString
    Control Get Text hDlg, %IDC_ComboFileSpec To FileSpec
    If ImpliedSearch Then FileSpec = "*" + Trim$(FileSpec,"*") + "*"
    Control Get Text hDlg, %IDC_ComboParent To ParentFolder : ParentFolder = Trim$(ParentFolder,"\")
    BuildMRU

    MatchingFiles = 0
    If MatchCase Then sTerm$ = SearchString Else sTerm$ = LCase$(SearchString)
    lenS = Len(sterm$)
    ListView Reset hDlg, %IDC_ListView

    'put filelist in array Files()
    If Flag Then GetFileList ParentFolder, FileSpec
    LoadListView (sterm$)  'put filenames with matching text into ListView
    SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %True, 0
    QueryPerformanceCounter qStop
    MousePtr 1

    ResizeWindow
    Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Files Searched: " + Str$(FileCount) + "        Matching files: " + _
         Str$(MatchingFiles) + "        Elapsed Time: " + Format$((qStop-qStart)/qFreq,"0.###") & " seconds"

End Sub

Sub LoadListView (sterm$)
   Local i,j,k,iResult,Flag,iRow,iCount, MaxLines As Long, text$

   'create search term list in array T(). don't always need it, but quick to create
   If SearchMode <> %SearchString Then
      If TrimSearchString Then
         While InStr(sTerm$, "  ") : Replace "  " With " " In sTerm$ : Wend       'remove double spaces
         sTerm$ = Trim$(sTerm$)                                                   'remove end spaces
      End If
      ReDim T(ParseCount(sTerm$, " ")-1) As String                             'create array of terms
      Parse sTerm$, T(), " "
   End If

   'fill ListView with file names that contain the string
   If AllFiles Then
      For i = 1 To FileCount :
         AddFileNameToListView i,i : Flag = 1    'new row in ListView
      Next i
      ListView Get Count hDlg, %IDC_ListView To  MatchingFiles
'      If Flag=0 Then Beep         '<--- just letting user know something went awry
   Else
      For i = 1 To FileCount
         If IsFalse(IsFile(Files(i).FileName)) Then Iterate For
         Open Files(i).FileName For Binary As #1 : Get$ #1, Lof(1), text$ : Close #1

         'adjust text to match search parameters
         If DetectUnix Then text$ = ConvertUnix(text$)
         If (MatchCase = 0) And (SearchMode <> %SearchRegExpr) Then text$ = LCase$(text$)  'RegExpr has to handle it's own case senstive searching

         'split file into array for further searching of individual linesas required
         If (DisplayMode <> %DisplayFiles) Or WordsOnLine Then
             iCount = ParseCount(text$,$CrLf)
             ReDim txtLines(iCount-1)
             Parse text$,txtLines(),$CrLf
             MaxLines = UBound(txtLines)
         End If

         Select Case SearchMode
            Case %SearchRegExpr   'search string is a RegExpr
               'does file have search string in it?

               RegExpr SearchString In text$ To iResult

               If iResult Then
                  'matching file, display it and any lines needed
                  Select Case DisplayMode
                     Case %DisplayFiles
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                     Case %DisplayNumbers, %DisplayContext
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                        For j = 0 To MaxLines
                           RegExpr SearchString In txtLines(j) To iResult
                           If iResult Then
                              If DisplayMode = %DisplayContext Then ShowPriorLines(j,iRow)
                              Incr iRow
                              ListView Insert Item hDlg, %IDC_ListView, iRow, 0, IIf$(DisplayMode=%DisplayNumbers,"[","**[") + LTrim$(Str$(j+1)) + "]"
                              ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
                              If DisplayMode = %DisplayContext Then ShowNextLines(j,MaxLines,iRow)
                              If DisplayMode = %DisplayContext Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                           End If
                        Next j
                        If DisplayMode = %DisplayNumbers Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                  End Select
                  Flag = 1
               End If

            Case %SearchString   'Complete String
               'does file have search string in it?
               iResult = InStrWholeWord(text$,sterm$)
               If iResult Then
                  'matching file, display it and any lines needed
                  Select Case DisplayMode
                     Case %DisplayFiles
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                     Case %DisplayNumbers, %DisplayContext
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                        For j = 0 To MaxLines
                           If InStrWholeWord(txtLines(j),sterm$) Then
                              If DisplayMode = %DisplayContext Then ShowPriorLines(j,iRow)
                              Incr iRow
                              ListView Insert Item hDlg, %IDC_ListView, iRow, 0, IIf$(DisplayMode=%DisplayNumbers,"[","**[") + LTrim$(Str$(j+1)) + "]"
                              ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
                              If DisplayMode = %DisplayContext Then ShowNextLines(j,MaxLines,iRow)
                              If DisplayMode = %DisplayContext Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                           End If
                        Next j
                        If DisplayMode = %DisplayNumbers Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                  End Select
                  Flag = 1
               End If

            Case %SearchAny   'Any Word in the document and Any Word in the line
               'does file have any of the words in it?
               iResult = 0
               For j = 0 To UBound(T)
                  If InStrWholeWord(text$,T(j)) Then iResult = 1 : Exit For
               Next j
               If iResult Then
                  'matching file, display it and any lines needed
                  Select Case DisplayMode
                     Case %DisplayFiles
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                     Case %DisplayNumbers, %DisplayContext
                        Incr iRow
                        AddFileNameToListView(iRow,i)   'new row
                        For j = 0 To MaxLines
                           For k = 0 To UBound(T)
                              If InStrWholeWord(txtLines(j),T(k)) Then
                                 If DisplayMode = %DisplayContext Then ShowPriorLines(j,iRow)
                                 Incr iRow
                                 ListView Insert Item hDlg, %IDC_ListView, iRow, 0, IIf$(DisplayMode=%DisplayNumbers,"[","**[") + LTrim$(Str$(j+1)) + "]"
                                 ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
                                 If DisplayMode = %DisplayContext Then ShowNextLines(j,MaxLines,iRow)
                                 If DisplayMode = %DisplayContext Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                                 Exit For
                              End If
                           Next k
                        Next j
                        If DisplayMode = %DisplayNumbers Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                  End Select
                  Flag = 1
               End If

            Case %SearchAll   'All Words somewhere in document OR all on one line if WordsOnLine=1
               If WordsOnLine = 0 Then
                  'does file have all the words in it
                  iResult = 1
                  For j = 0 To UBound(T)
                     If InStrWholeWord(text$,T(j)) = 0  Then iResult = 0 : Exit For
                  Next j
                  If iResult Then
                     Select Case DisplayMode
                        Case %DisplayFiles
                           Incr iRow
                           AddFileNameToListView(iRow,i)   'new row
                        Case %DisplayNumbers, %DisplayContext
                           Incr iRow
                           AddFileNameToListView(iRow,i)   'new row
                           For j = 0 To MaxLines
                              For k = 0 To UBound(T)
                                 If InStrWholeWord(txtLines(j),T(k)) Then
                                    If DisplayMode = %DisplayContext Then ShowPriorLines(j,iRow)
                                    Incr iRow
                                    ListView Insert Item hDlg, %IDC_ListView, iRow, 0, IIf$(DisplayMode=%DisplayNumbers,"[","**[") + LTrim$(Str$(j+1)) + "]"
                                    ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
                                    If DisplayMode = %DisplayContext Then ShowNextLines(j,MaxLines,iRow)
                                    If DisplayMode = %DisplayContext Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                                    Exit For
                                 End If
                              Next k
                           Next j
                           If DisplayMode = %DisplayNumbers Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                     End Select
                     Flag = 1
                  End If
               Else
                  'does the file have any line with all the terms in it?
                  For k = 0 To MaxLines
                     iResult = 1
                     For j = 0 To UBound(T)
                        If InStrWholeWord(txtLines(k),T(j)) = 0 Then iResult = 0 : Exit
                     Next j
                     If iResult = 1 Then : Exit For
                  Next k
                  If iResult Then
                     Select Case DisplayMode
                        Case %DisplayFiles
                           Incr iRow
                           AddFileNameToListView(iRow,i)   'new row
                        Case %DisplayNumbers, %DisplayContext
                           Incr iRow
                           AddFileNameToListView(iRow,i)   'new row
                           For j = 0 To MaxLines
                              iResult = 1
                              For k = 0 To UBound(T)
                                 If InStrWholeWord(txtLines(j),T(k)) = 0 Then iResult = 0 : Exit
                              Next k
                              If iResult Then
                                 If DisplayMode = %DisplayContext Then ShowPriorLines(j,iRow)
                                 Incr iRow
                                 ListView Insert Item hDlg, %IDC_ListView, iRow, 0, IIf$(DisplayMode=%DisplayNumbers,"[","**[") + LTrim$(Str$(j+1)) + "]"
                                 ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
                                 If DisplayMode = %DisplayContext Then ShowNextLines(j,MaxLines,iRow)
                                 If DisplayMode = %DisplayContext Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                              End If
                           Next j
                           If DisplayMode = %DisplayNumbers Then Incr iRow : ListView Insert Item hDlg, %IDC_ListView, iRow, 0, ""  'add a blank lines
                     End Select
                     Flag = 1
                  End If
               End If
         End Select
      Next i
'      If Flag=0 Then Beep         '<--- just letting user know something went awry
   End If
End Sub

Sub AddFileNameToListView(iRow As Long, iPos As Long)
    Local UST,LST As SystemTime, temp$
    Incr MatchingFiles
    Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Folders Searched: " + Str$(FolderCount) + "        Matching Files: " + Str$(MatchingFiles)

    temp$ = Files(iPos).Filename
    ListView Insert Item hDlg, %IDC_ListView, iRow, 0, PathName$(Namex,temp$)
    ListView Set Text    hDlg, %IDC_ListView, iRow, 2, Files(iPos).FileName

    FileTimeToSystemTime(ByVal VarPtr(Files(iPos).LastWriteTime),UST)  'UTC
    SystemTimeToTzSpecificLocalTime(ByVal %Null, UST,LST)              'Local
    ListView Set Text hDlg, %IDC_ListView, iRow,3, _
        Format$(LST.wYear,"00") + "-" + Format$(LST.wMonth,"00") + "-" + Format$(LST.wDay,"00") + "  " _
        + Format$(LST.wHour,"00") + ":" + Format$(LST.wMinute,"00") '+ ":" + Format$(LST.wSecond,"00")

    temp$ = Str$(Files(iPos).FileSizeHigh * &H100000000 + Files(iPos).FileSizeLow)
    If Val(temp$) < 1024 Then temp$ = "1024"
    ListView Set Text hDlg, %IDC_ListView, iRow,4, Format$(Val(temp$)/1024,"#,###,###") ' + "    "
End Sub

Function ShowPriorLines(i As Long, iRow As Long) As Long
    Local j As Long
    For j = (i-ContextWidth) To (i-1)
        If j < 0 Then Iterate For
        Incr iRow
        ListView Insert Item hDlg, %IDC_ListView, iRow, 0, "    [" + LTrim$(Str$(j+1)) + "]"
        ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
    Next j
End Function

Function ShowNextLines(i As Long, MaxLines As Long, iRow As Long) As Long
    Local j As Long
    For j = i+1 To i+ContextWidth
        If j > MaxLines Then Exit For
        Incr iRow
        ListView Insert Item hDlg, %IDC_ListView, iRow, 0, "    [" + LTrim$(Str$(j+1)) + "]"
        ListView Set Text    hDlg, %IDC_ListView, iRow, 2, txtLines(j)
    Next j
End Function

Sub GetFileList (ParentFolder$, FileSpec$)
   Local iPos As Long, tempDIR As DirData, temp$, FileAttributes As Long
   ReDim Folders(500), Files(5000)
   FileAttributes = %Normal + %Hidden*FileHidden + %System*FileSystem + %SubDir*SubFolders
   FileCount = 0 : FolderCount = 0 : Reset Files(), Folders()
   Folders(iPos).FileName = ParentFolder$     'no ending \
   Do While Len(Folders(iPos).FileName)
       temp$ = Dir$(Folders(iPos).FileName + "\*.*", FileAttributes, To tempDir)
       Do While Len(temp$)
           tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
           If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'files
               If PathMatchSpec((PathName$(Namex,tempDir.Filename)), (FileSpec$)) Then
                   Incr FileCount  :  Files(FileCount) = tempDir
                   If FileCount >= UBound(Files) Then ReDim Preserve Files(UBound(Files)+500)
               End If
           Else                                                                'folder
               Incr FolderCount    :  Folders(FolderCount) = tempDir
               If FolderCount >= UBound(Folders) Then ReDim Preserve Folders(UBound(Folders)+5000)
           End If
           temp$ = Dir$(Next, To tempDir)
           Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Folders Searched: " + Str$(FolderCount) + "        Files Found: " + Str$(FileCount)
       Loop
       Incr iPos
   Loop
End Sub

Sub CreateToolbar
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Folder,  %TbStyle_Button, "Folder"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_SearchAll,  %TbStyle_Button, "All"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_SubFolders,  %TbStyle_Check, "SubFolders"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_MatchCase,  %TbStyle_Check, "Match Case"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20

    If WideToolbar Then
       Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Files,  %TbStyle_CheckGroup, "Files"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_LineNumbers,  %TbStyle_CheckGroup, "Line#"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Context,  %TbStyle_CheckGroup, "Context"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    End If

    If WideToolbarB Then
       Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_AllWords,  %TbStyle_CheckGroup, "Exact"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_AndWords,  %TbStyle_CheckGroup, "AND"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_OrWords,  %TbStyle_CheckGroup, "OR"
       Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_RegEx,  %TbStyle_CheckGroup, "RegEx"
       Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    End If

    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Sub CreateImageListPopUp
    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xfolder"      '1
    ImageList Add Icon hImageList, "aaa"          '2
    ImageList Add Icon hImageList, "xsubfolders"  '3
    ImageList Add Icon hImageList, "xallfiles"    '4
    ImageList Add Icon hImageList, "xmatchcase"   '5
    ImageList Add Icon hImageList, "xsettings"    '6
    ImageList Add Icon hImageList, "xhelp"        '7
    ImageList Add Icon hImageList, "xfiles"       '8
    ImageList Add Icon hImageList, "xlinenumber"  '9
    ImageList Add Icon hImageList, "xcontext"    '10
    ImageList Add Icon hImageList, "xallwords"   '11
    ImageList Add Icon hImageList, "xandwords"   '12
    ImageList Add Icon hImageList, "xorwords"    '13
    ImageList Add Icon hImageList, "xregex"      '14
    ImageList Add Icon hImageList, "xsearchall"  '15

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Files", %IDM_Files, %MF_Enabled
    Menu Add String, hPopupSettings, "Line Numbers", %IDM_Lines, %MF_Enabled
    Menu Add String, hPopupSettings, "Context", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "Complete String", %IDM_CompleteString, %MF_Enabled
    Menu Add String, hPopupSettings, "All Words (AND)", %IDM_AllWords, %MF_Enabled
    Menu Add String, hPopupSettings, "Any Word (OR)", %IDM_AnyWord, %MF_Enabled
    Menu Add String, hPopupSettings, "Regular Expressions", %IDM_RegExp, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "Hidden", %IDM_FileHidden, %MF_Enabled
    Menu Add String, hPopupSettings, "System", %IDM_FileSystem, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "Whole Words", %IDM_WholeWords, %MF_Enabled
    Menu Add String, hPopupSettings, "Words On Line (AND Only)", %IDM_WordsOnLine, %MF_Enabled
    Menu Add String, hPopupSettings, "Detect Unix Line Feed", %IDM_DetectUnix, %MF_Enabled
    Menu Add String, hPopupSettings, "Trim Search String", %IDM_TrimSearchString, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "Color Lines", %IDM_ColorLines, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSearch On Startup", %IDM_AutoSearch, %MF_Enabled
    Menu Add String, hPopupSettings, "Implied Search", %IDM_ImpliedSearch, %MF_Enabled
    Menu Add String, hPopupSettings, "All Toolbar Buttons", %IDM_WideToolbar, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Context, %MF_Enabled
    Menu Add String, hPopupSettings, "Select Context Width", %IDM_ContextWidth, %MF_Enabled
End Sub

Sub SetMenusAndToolbarButtons
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SubFolders, %TBState_Checked * SubFolders Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_MatchCase, %TBState_Checked * MatchCase Or %TBState_Enabled

   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Files, %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LineNumbers, %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Context, %TBState_Enabled
   Select Case DisplayMode
      Case %DisplayFiles   : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Files, %TBState_Checked Or %TBState_Enabled
      Case %DisplayNumbers : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LineNumbers, %TBState_Checked Or %TBState_Enabled
      Case %DisplayContext : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Context, %TBState_Checked Or %TBState_Enabled
   End Select

   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AllWords, %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AndWords, %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_OrWords, %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_RegEx, %TBState_Enabled
   Select Case SearchMode
      Case %SearchString   : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AllWords, %TBState_Checked Or %TBState_Enabled
      Case %SearchAll      : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AndWords, %TBState_Checked Or %TBState_Enabled
      Case %Searchany      : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_OrWords, %TBState_Checked Or %TBState_Enabled
      Case %SearchRegExpr  : Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_RegEx, %TBState_Checked Or %TBState_Enabled
   End Select

   'Menus
   Menu Set State hPopupSettings, ByCmd %IDM_Files, 0
   Menu Set State hPopupSettings, ByCmd %IDM_Lines, 0
   Menu Set State hPopupSettings, ByCmd %IDM_Context, 0
   Select Case DisplayMode
        Case %DisplayFiles   : Menu Set State hPopupSettings, ByCmd %IDM_Files, 8
        Case %DisplayNumbers : Menu Set State hPopupSettings, ByCmd %IDM_Lines, 8
        Case %DisplayContext : Menu Set State hPopupSettings, ByCmd %IDM_Context, 8
   End Select

   Menu Set State hPopupSettings, ByCmd %IDM_FileHidden, FileHidden * 8
   Menu Set State hPopupSettings, ByCmd %IDM_FileSystem, FileSystem * 8
   Menu Set State hPopupSettings, ByCmd %IDM_ColorLines, ColorLines * 8
   Menu Set State hPopupSettings, ByCmd %IDM_AutoSearch, AutoSearch * 8
   Menu Set State hPopupSettings, ByCmd %IDM_DetectUnix, DetectUnix * 8
   Menu Set State hPopupSettings, ByCmd %IDM_TrimSearchString, TrimSearchString * 8
   Menu Set State hPopupSettings, ByCmd %IDM_WholeWords, WholeWords * 8
   Menu Set State hPopupSettings, ByCmd %IDM_WordsOnLine, WordsOnLine * 8
   Menu Set State hPopupSettings, ByCmd %IDM_WideToolbar, WideToolbar * 8
   Menu Set State hPopupSettings, ByCmd %IDM_ImpliedSearch, ImpliedSearch * 8

   Menu Set State hPopupSettings, ByCmd %IDM_CompleteString, 0
   Menu Set State hPopupSettings, ByCmd %IDM_AllWords, 0
   Menu Set State hPopupSettings, ByCmd %IDM_AnyWord, 0
   Menu Set State hPopupSettings, ByCmd %IDM_RegExp, 0
   Select Case SearchMode
        Case 1 : Menu Set State hPopupSettings, ByCmd %IDM_CompleteString, 8
        Case 2 : Menu Set State hPopupSettings, ByCmd %IDM_AllWords, 8
        Case 3 : Menu Set State hPopupSettings, ByCmd %IDM_AnyWord, 8
        Case 4 : Menu Set State hPopupSettings, ByCmd %IDM_RegExp, 8
   End Select
End Sub

Sub SubClassControls
   Local ComboInfo As ComboBoxInfo

   Control Handle hDlg, %IDC_ComboTerms To hComboTerms
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(GetDlgItem(hDlg,%IDC_ComboTerms), ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboTermsEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldCBTermsProc = SetWindowLong(hComboTermsEdit, %GWL_WndProc, CodePtr(NewCBTermsProc))   'subclass a control

   Control Handle hDlg, %IDC_ComboParent To hComboParent
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(GetDlgItem(hDlg,%IDC_ComboParent), ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboParentEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldCBParentProc = SetWindowLong(hComboParentEdit, %GWL_WndProc, CodePtr(NewCBParentProc))   'subclass a control

   Control Handle hDlg, %IDC_ComboFileSpec To hComboFileSpec
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)
   GetComboBoxInfo(GetDlgItem(hDlg,%IDC_ComboFileSpec), ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboFileSpecEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldCBFileSpecProc = SetWindowLong(hComboFileSpecEdit, %GWL_WndProc, CodePtr(NewCBFileSpecProc))   'subclass a control

   OldLVProc = SetWindowLong(hListView, %GWL_WndProc, CodePtr(NewLVProc))  'subclass
End Sub

Function NewLVProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local hdnptr As HD_NOTIFY Ptr, hdiptr As HD_ITEM Ptr, iResult As Long, w,h,wcol As Long, ww As Single
   Select Case Msg
      Case %WM_Notify
         hdnptr = lParam
         hdiptr = @hdnptr.pitem
         Select Case @hdnptr.hdr.code
            Case %hdn_EndTrackW
                iResult = @hdnptr.iItem
                Dialog Post hDlg, %WM_User+500, iResult, 0
         End Select
   End Select
   Function = CallWindowProc(OldLVProc, hWnd, Msg, wParam, lParam)
End Function

Function NewCBTermsProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTerms, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldCBTermsProc, hWnd, Msg, wParam, lParam)
End Function

Function NewCBParentProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextParent, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldCBParentProc, hWnd, Msg, wParam, lParam)
End Function

Function NewCBFileSpecProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextFileSpec, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldCBFileSPecProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenus
   Menu New PopUp To hContextListView
   Menu Add String, hContextListView, "Copy List",  %IDM_CopyList,  %MF_Enabled
   Menu Add String, hContextListView, "Clear List",  %IDM_ClearList,  %MF_Enabled
   Menu Add String, hContextListView, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextListView, "Open File Location",  %IDM_OpenLocation,  %MF_Enabled
   Menu Add String, hContextListView, "Use As Parent",  %IDM_UseAsParent,  %MF_Enabled
   Menu Add String, hContextListView, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextListView, "Select Font", %IDM_SelectFont, %MF_Enabled
   Menu Add String, hContextListView, "-",  %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextListView, "Create Merge File",  %IDM_MergeFile,  %MF_Enabled

   Menu New PopUp To hContextTerms
   Menu Add String, hContextTerms, "Cut",  %IDM_CutTerms,  %MF_Enabled
   Menu Add String, hContextTerms, "Copy",  %IDM_CopyTerms,  %MF_Enabled
   Menu Add String, hContextTerms, "Paste",  %IDM_PasteTerms,  %MF_Enabled
   Menu Add String, hContextTerms, "Delete", %IDM_DeleteTerms,  %MF_Enabled
   Menu Add String, hContextTerms, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextTerms, "Clear Search Strings", %IDM_ClearTerms,  %MF_Enabled

   Menu New PopUp To hContextParent
   Menu Add String, hContextParent, "Cut",  %IDM_CutParent,  %MF_Enabled
   Menu Add String, hContextParent, "Copy",  %IDM_CopyParent,  %MF_Enabled
   Menu Add String, hContextParent, "Paste",  %IDM_PasteParent,  %MF_Enabled
   Menu Add String, hContextParent, "Delete", %IDM_DeleteParent,  %MF_Enabled
   Menu Add String, hContextParent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextParent, "Open Parent Folder", %IDM_OpenParent,  %MF_Enabled
   Menu Add String, hContextParent, "Up One Level", %IDM_UpOneLevel,  %MF_Enabled
   Menu Add String, hContextParent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextParent, "Clear Parent Folders", %IDM_ClearParent,  %MF_Enabled

   Menu New PopUp To hContextFileSpec
   Menu Add String, hContextFileSpec, "Cut",  %IDM_CutFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Copy",  %IDM_CopyFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Paste",  %IDM_PasteFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "Delete", %IDM_DeleteFileSpec,  %MF_Enabled
   Menu Add String, hContextFileSpec, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextFileSpec, "Clear File Specs", %IDM_ClearFileSpec,  %MF_Enabled
End Sub

Sub BuildMRU
   Local lRes As Long

    'always put most recent terms/parent/filespec at top. if exists add search term, if new move to top
   If Len(Trim$(SearchString)) Then
       ComboBox Find Exact hDlg, %IDC_ComboTerms, 1, SearchString To lRes
       If lRes Then ComboBox Delete hDlg, %IDC_ComboTerms, lRes
       ComboBox Insert hDlg, %IDC_ComboTerms, 1, SearchString
       ComboBox Select hDlg, %IDC_ComboTerms, 1
   End If

   If Len(Trim$(ParentFolder)) Then
       ComboBox Find Exact hDlg, %IDC_ComboParent, 1, ParentFolder To lRes
       If lRes Then ComboBox Delete hDlg, %IDC_ComboParent, lRes
       ComboBox Insert hDlg, %IDC_ComboParent, 1, ParentFolder
       ComboBox Select hDlg, %IDC_ComboParent, 1
   End If

   If Len(Trim$(FileSpec)) Then
       ComboBox Find Exact hDlg, %IDC_ComboFileSpec, 1, FileSpec To lRes
       If lRes Then ComboBox Delete hDlg, %IDC_ComboFileSpec, lRes
       ComboBox Insert hDlg, %IDC_ComboFileSpec, 1, FileSpec
       ComboBox Select hDlg, %IDC_ComboFileSpec, 1
   End If
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
        If UCase$(szTemp) = "EDIT"   Then @cst.cx = 190 : @cst.y = @cst.y - 130  'textbox
        If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style) ' Or %ES_Password
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 130                'dialog
    End If
End Function

Sub EnterContextWidth
   Local temp$, x,y As Long
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("Enter number of context lines:", "Context Width", Str$(ContextWidth),x+50,y+50)
   If Val(temp$) Then ContextWidth = Val(temp$)
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(6)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help              : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDT_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A      : ac(c).cmd   = %IDT_SearchAll         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDT_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O      : ac(c).cmd   = %IDT_Folder            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_WideToolbar       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W      : ac(c).cmd   = %IDM_WideToolbarB      : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateMergeFile
    Local text$,temp$,fName$, i, iCount As Long
    ListView Get Count hDlg, %IDC_ListView To iCount
    If iCount = 0 Then Exit Sub
    MousePtr 11
    fName$ = Exe.Path$ + "mergefile.txt"
    Open fName$ For Output As #2
    For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListView, i, 2 To temp$
       Open temp$ For Binary As #1 : Get$ #1, Lof(1), text$ : Close #1
       Print #2, temp$ + String$(80-Len(temp$),"=")
       Print #2, text$
    Next i
    Close #2
    MousePtr 1
    i = ShellExecute(hDlg, "Open", (fName$), $Nul, $Nul, %SW_ShowNormal)
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Folder     : Function = "Select Parent Folder"
      Case %IDT_Search     : Function = "Search For Matching Files (Extension + Search String)"
      Case %IDT_SearchAll  : Function = "Search For Matching Files (Extension Only)"
      Case %IDT_SubFolders : Function = "Include SubFolders In Search"
      Case %IDT_MatchCase  : Function = "Case Sensitive Search"

      Case %IDT_Files      : Function = "Display Only File Names"
      Case %IDT_LineNumbers: Function = "Display Line Numbers"
      Case %IDT_Context    : Function = "Display Context Lines"

      Case %IDT_AllWords   : Function = "Exact String Search"
      Case %IDT_AndWords   : Function = "All Words Search"
      Case %IDT_OrWords    : Function = "Any Word Search"
      Case %IDT_RegEx      : Function = "Regular Expression Search"

      Case %IDT_Settings   : Function = "Settings"
      Case %IDT_Help       : Function = "Open Online Help"
      Case Else            : Function = "Unknown"
   End Select
End Function

' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
' this routine sorts on the .L (Long) element of the UDT
' Function = IIf(A.L > B.L,-1,+1)        'descending numeric

Function SortByNameA(A As DirData, B As DirData) As Long
    Function = IIf(PathName$(Namex,A.FileName) > PathName$(Namex,B.FileName), -1, +1)
End Function

Function SortByNameD(A As DirData, B As DirData) As Long
    Function = IIf(PathName$(Namex,A.FileName) < PathName$(Namex,B.FileName), -1, +1)
End Function

Function SortByPathA(A As DirData, B As DirData) As Long
    Function = IIf(A.FileName > B.FileName, -1, +1)
End Function

Function SortByPathD(A As DirData, B As DirData) As Long
    Function = IIf(A.FileName < B.FileName, -1, +1)
End Function

Function SortByDateA(A As DirData, B As DirData) As Long
    Function = IIf(A.LastWriteTime < B.LastWriteTime, -1, +1)
End Function

Function SortByDateD(A As DirData, B As DirData) As Long
    Function = IIf(A.LastWriteTime > B.LastWriteTime, -1, +1)
End Function

Function SortBySizeA(A As DirData, B As DirData) As Long
    Local sA,sB As Long
    sA = A.FileSizeHigh * &H100000000 + A.FileSizeLow
    sB = B.FileSizeHigh * &H100000000 + B.FileSizeLow
    Function = IIf(sA < sB, -1, +1)
End Function

Function SortBySizeD(A As DirData, B As DirData) As Long
    Local sA,sB As Long
    sA = A.FileSizeHigh * &H100000000 + A.FileSizeLow
    sB = B.FileSizeHigh * &H100000000 + B.FileSizeLow
    Function = IIf(sA > sB, -1, +1)
End Function

Sub SelectAppFont
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then
       FontName = fName$ : FontSize = fSize : FontStyle = fStyle
       Font New FontName, FontSize, FontStyle To hFont
       Control Set Font hDlg, %IDC_ListView, hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function ConvertUnix(temp$) As String
    Local iLen,iPos As Long
    iPos = 1
    Do
       iPos = InStr(iPos,temp$,Chr$(10))
       If iPos Then
           If Mid$(temp$,iPos-1,1)<>Chr$(13) Then temp$ = StrInsert$(temp$, Chr$(13), iPos) : Incr iPos
           Incr iPos
       End If
    Loop While iPos
    Function = temp$
End Function

Function InstrWholeWord(smain$,sterm$) As Long
    Local iPos,FlagLeft,FlagRight As Long, rChar$, lChar$

    'find sterm$ (not the whole word version)
    iPos = 1 : iPos = InStr(iPos, smain$, sterm$)
    If WholeWords=0 Then Function = iPos : Exit Function

    Do While iPos
        FlagLeft = %False : FlagRight = %False
        'check left side
        If iPos = 1 Then
            FlagLeft = %True                   'flush with left side of line
        Else
            lChar$ = Mid$(smain$,iPos-1,1)
            FlagLeft = IsTrue(Verify(lChar$, $ValidCharacters))
        End If
        'check right side
        If iPos = Len(smain$)-Len(sTerm$)+1 Then
            FlagRight = %True                 'flush with right side of line
        Else
            rChar$ = Mid$(smain$,iPos + Len(sterm$),1)
            FlagRight = IsTrue(Verify(rChar$, $ValidCharacters))
        End If
        'Done?
        If FlagLeft And FlagRight Then Exit Do
        iPos = InStr(iPos+Len(sterm$), smain$, sterm$)
    Loop
    Function = iPos
End Function

Sub ResizeWindowX
   Local x,y,w,h As Long
   ListView Get Column hDlg, %IDC_ListView, 1 To x
   ListView Get Column hDlg, %IDC_ListView, 3 To y
   ListView Get Column hDlg, %IDC_ListView, 4 To w
   x = x + y + w
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_ComboFileSpec, w-230, 20
   Control Set Size hDlg, %IDC_ComboParent, w-20, 20
   Control Set Size hDlg, %IDC_ListView, w-20, h-130
'           PostMessage hComboFileSpecEdit,%CB_SeteditSel, 0, Mak(Long,-1,0)
'           PostMessage hComboParentEdit,%CB_SeteditSel, 0, Mak(Long,-1,0)
   ListView Set Column hDlg, %IDC_ListView, 2, w - x - 27 + 20 * IsTrue(GetWindowLong(hListView, %GWL_STYLE) And %WS_VScroll)
End Sub

Sub ResizeWindow
   Local x,y,w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_ComboFileSpec, w-230, 20
   Control Set Size hDlg, %IDC_ComboParent, w-20, 20
   Control Set Size hDlg, %IDC_ListView, w-20, h-130

   Control Get Client hDlg, %IDC_ListView To w,h
   w = w + 20 * IsTrue(GetWindowLong(hListView, %GWL_STYLE) And %WS_VScroll)
   ListView Set Column hDlg, %IDC_ListView, 1, colName * w / 100
   ListView Set Column hDlg, %IDC_ListView, 2, colPath * w / 100
   ListView Set Column hDlg, %IDC_ListView, 3, colDate * w / 100
   ListView Set Column hDlg, %IDC_ListView, 4, colSize * w / 100

'           PostMessage hComboFileSpecEdit,%CB_SeteditSel, 0, Mak(Long,-1,0)
'           PostMessage hComboParentEdit,%CB_SeteditSel, 0, Mak(Long,-1,0)
End Sub

Sub ResizeColumns(iCol As Long)
    Local w,h,iResult,wCol,ww As Long
    Control Get Client hDlg, %IDC_ListView To w,h
    ListView Get Column hDlg, %IDC_Listview, iCol+1 To wCol
    Select Case iCol
        Case 0  'name
            ww = colPath + colDate + colSize
            colName =  100 * wCol / w
            colPath = colPath / ww * (100-colName)
            colDate = colDate / ww * (100-colName)
            colSize = colSize / ww * (100-colName)
        Case 1  'path
            ww = colName + colDate + colSize
            colPath =  100 * wCol / w
            colName = colName / ww * (100-colPath)
            colDate = colDate / ww * (100-colPath)
            colSize = colSize / ww * (100-colPath)
        Case 2  'date
            ww = colName + colPath + colSize
            colDate =  100 * wCol / w
            colName = colName / ww * (100-colDate)
            colPath = colPath / ww * (100-colDate)
            colSize = colSize / ww * (100-colDate)
        Case 3  'size
            ww = colPath + colName + colDate
            colSize =  100 * wCol / w
            colName = colName / ww * (100-colSize)
            colPath = colPath / ww * (100-colSize)
            colDate = colDate / ww * (100-colSize)
        Case Else
    End Select
End Sub

Sub RestoreSession
   Exit Sub  '<----------- still in work, no happy with result
   Local i As Long, fName$
   'read Files()
   fName$ = "session_files.dat"
   If IsTrue(IsFile(fName$)) Then
      ReDim Files(FileCount)
      Open fName$ For Binary As #1
      Get #1,,Files()
      Close #1
      'put Files() into ListView
      For i = 1 To FileCount
         AddFileNameToListView i,i
      Next i
      Close #1
   End If

   'read Files()/Folders()
   fName$ = "session_folders.dat"
   If IsTrue(IsFile(fName$)) Then
      ReDim Folders(FolderCount)
      Open fName$ For Binary As #1
      Get #1,,Folders()
      Close #1
   End If
End Sub

Sub SaveSession
   Exit Sub  '<----------- still in work, no happy with result
   Local fName$
   'PUT Files()
   fName$ = "session_files.dat"
   If IsTrue(IsFile(fName$)) Then Kill fName$
   Open fName$ For Binary As #1
   Put #1,, Files()
   Close #1
   'PUT Folder()
   fName$ = "session_folders.dat"
   If IsTrue(IsFile(fName$)) Then Kill fName$
   Open fName$ For Binary As #1
   Put #1,, Files()
   Close #1
End Sub
